Modify

Opened 2 years ago

Last modified 2 years ago

#14283 new defect

RejectedExecutionException: Task PutEvent rejected from java.util.concurrent.ThreadPoolExecutor

Reported by: naoliv Owned by: team
Priority: normal Milestone:
Component: Core imagery Version:
Keywords: Cc: wiktorn

Description

I am seeing some messages like this:

java.util.concurrent.RejectedExecutionException: Task PutEvent for key: Imagem aérea do Bing:http://www.bing.com/maps/12/1466/2323 value: org.openstreetmap.josm.data.cache.BufferedImageCacheEntry@7f10a5 rejected from java.util.concurrent.ThreadPoolExecutor@47ae2d59[Terminated, pool size = 0, active threads = 0, queued tasks = 0, completed tasks = 4366]
	at java.util.concurrent.ThreadPoolExecutor$AbortPolicy.rejectedExecution(ThreadPoolExecutor.java:2047)
	at java.util.concurrent.ThreadPoolExecutor.reject(ThreadPoolExecutor.java:823)
	at java.util.concurrent.ThreadPoolExecutor.execute(ThreadPoolExecutor.java:1369)
	at org.apache.commons.jcs.engine.PooledCacheEventQueue.put(PooledCacheEventQueue.java:127)
	at org.apache.commons.jcs.engine.AbstractCacheEventQueue.addPutEvent(AbstractCacheEventQueue.java:187)
	at org.apache.commons.jcs.auxiliary.disk.AbstractDiskCache.update(AbstractDiskCache.java:215)
	at org.apache.commons.jcs.engine.control.CompositeCache.updateAuxiliaries(CompositeCache.java:368)
	at org.apache.commons.jcs.engine.control.CompositeCache.update(CompositeCache.java:253)
	at org.apache.commons.jcs.engine.control.CompositeCache.update(CompositeCache.java:205)
	at org.apache.commons.jcs.access.CacheAccess.put(CacheAccess.java:239)
	at org.openstreetmap.josm.data.cache.JCSCachedTileLoaderJob.loadObject(JCSCachedTileLoaderJob.java:370)
	at org.openstreetmap.josm.data.cache.JCSCachedTileLoaderJob.run(JCSCachedTileLoaderJob.java:240)
	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)
	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)
	at java.lang.Thread.run(Thread.java:745)
java.util.concurrent.RejectedExecutionException: Task PutEvent for key: Imagem aérea do Bing:http://www.bing.com/maps/12/1466/2322 value: org.openstreetmap.josm.data.cache.BufferedImageCacheEntry@e313608 rejected from java.util.concurrent.ThreadPoolExecutor@47ae2d59[Terminated, pool size = 0, active threads = 0, queued tasks = 0, completed tasks = 4366]
	at java.util.concurrent.ThreadPoolExecutor$AbortPolicy.rejectedExecution(ThreadPoolExecutor.java:2047)
	at java.util.concurrent.ThreadPoolExecutor.reject(ThreadPoolExecutor.java:823)
	at java.util.concurrent.ThreadPoolExecutor.execute(ThreadPoolExecutor.java:1369)
	at org.apache.commons.jcs.engine.PooledCacheEventQueue.put(PooledCacheEventQueue.java:127)
	at org.apache.commons.jcs.engine.AbstractCacheEventQueue.addPutEvent(AbstractCacheEventQueue.java:187)
	at org.apache.commons.jcs.auxiliary.disk.AbstractDiskCache.update(AbstractDiskCache.java:215)
	at org.apache.commons.jcs.engine.control.CompositeCache.updateAuxiliaries(CompositeCache.java:368)
	at org.apache.commons.jcs.engine.control.CompositeCache.update(CompositeCache.java:253)
	at org.apache.commons.jcs.engine.control.CompositeCache.update(CompositeCache.java:205)
	at org.apache.commons.jcs.access.CacheAccess.put(CacheAccess.java:239)
	at org.openstreetmap.josm.data.cache.JCSCachedTileLoaderJob.loadObject(JCSCachedTileLoaderJob.java:370)
	at org.openstreetmap.josm.data.cache.JCSCachedTileLoaderJob.run(JCSCachedTileLoaderJob.java:240)
	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)
	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)
	at java.lang.Thread.run(Thread.java:745)
(...)

Maybe related with [11444]?

JOSM:

URL:http://josm.openstreetmap.de/svn/trunk
Repository:UUID: 0c6e7542-c601-0410-84e7-c038aed88b3b
Last:Changed Date: 2017-01-22 21:57:07 +0100 (Sun, 22 Jan 2017)
Build-Date:2017-01-23 02:32:02
Revision:11488
Relative:URL: ^/trunk

Identification: JOSM/1.5 (11488 pt_BR) Linux Debian GNU/Linux 9.0 (stretch)
Memory Usage: 284 MB / 4029 MB (44 MB allocated, but free)
Java version: 1.8.0_111-8u111-b14-3-b14, Oracle Corporation, OpenJDK 64-Bit Server VM
Screen: :0.0 1920x1080
Maximum Screen Size: 1920x1080
Java package: openjdk-8-jre:amd64-8u111-b14-3
Java ATK Wrapper package: libatk-wrapper-java:all-0.33.3-13
VM arguments: [-Dawt.useSystemAAFontSettings=on]

Attachments (0)

Change History (5)

comment:1 Changed 2 years ago by wiktorn

It's probably related to latest changes in JCS.

Do I understand correctly - that the messages show in console, but do not interfere with the work?

Does it happen often, or only from time to time? How did you notice?

Any clues how can I reproduce?

comment:2 Changed 2 years ago by naoliv

Yes, I am seeing the messages in the terminal and can't observe any issues inside JOSM.

I don't know how to reproduce this (the 2 times when I saw it I was just normally moving the map, fixing stuff, etc).
Nothing happened while trying to reproduce it now, but after closing JOSM they appeared:

[INFO] BlockDiskKeyStore - Region [TMS_BLOCK_v2] Finished saving keys. It took 319ms. to store 38922 keys.  Key file length [3778846]
[INFO] BlockDiskCache - Region [TMS_BLOCK_v2] Shutdown complete.
[INFO] CompositeCache - In DISPOSE, [TMS] disposing of memory cache.
[INFO] AbstractMemoryCache - Memory Cache dispose called.
2017-01-24 09:00:27.452 SEVERE: Handled by bug report queue: java.util.concurrent.RejectedExecutionException: Task PutEvent for key: Bing aerial imagery:http://www.bing.com/maps/14/5836/9279 value: org.openstreetmap.josm.data.cache.BufferedImageCacheEntry@20ae54f3 rejected from java.util.concurrent.ThreadPoolExecutor@1bd0f37c[Terminated, pool size = 0, active threads = 0, queued tasks = 0, completed tasks = 3898]
java.util.concurrent.RejectedExecutionException: Task PutEvent for key: Bing aerial imagery:http://www.bing.com/maps/14/5836/9279 value: org.openstreetmap.josm.data.cache.BufferedImageCacheEntry@20ae54f3 rejected from java.util.concurrent.ThreadPoolExecutor@1bd0f37c[Terminated, pool size = 0, active threads = 0, queued tasks = 0, completed tasks = 3898]
	at java.util.concurrent.ThreadPoolExecutor$AbortPolicy.rejectedExecution(ThreadPoolExecutor.java:2047)
	at java.util.concurrent.ThreadPoolExecutor.reject(ThreadPoolExecutor.java:823)
	at java.util.concurrent.ThreadPoolExecutor.execute(ThreadPoolExecutor.java:1369)
	at org.apache.commons.jcs.engine.PooledCacheEventQueue.put(PooledCacheEventQueue.java:127)
	at org.apache.commons.jcs.engine.AbstractCacheEventQueue.addPutEvent(AbstractCacheEventQueue.java:187)
	at org.apache.commons.jcs.auxiliary.disk.AbstractDiskCache.update(AbstractDiskCache.java:215)
	at org.apache.commons.jcs.engine.control.CompositeCache.updateAuxiliaries(CompositeCache.java:368)
	at org.apache.commons.jcs.engine.control.CompositeCache.update(CompositeCache.java:253)
	at org.apache.commons.jcs.engine.control.CompositeCache.update(CompositeCache.java:205)
	at org.apache.commons.jcs.access.CacheAccess.put(CacheAccess.java:239)
	at org.openstreetmap.josm.data.cache.JCSCachedTileLoaderJob.loadObject(JCSCachedTileLoaderJob.java:370)
	at org.openstreetmap.josm.data.cache.JCSCachedTileLoaderJob.run(JCSCachedTileLoaderJob.java:240)
	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)
	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)
	at java.lang.Thread.run(Thread.java:745)

(a lot of the same messages here)

It happens with other layers too, as I saw now:

2017-01-24 09:00:27.711 INFO: GET http://c.tiles.mapbox.com/v3/tmpsantos.hgda0m6h/14/5834/9276.png -> 404 (33 B)
2017-01-24 09:00:27.715 SEVERE: Handled by bug report queue: java.util.concurrent.RejectedExecutionException: Task PutEvent for key: IBGE Mapa de Setores Urbanos:http://{switch:a,b,c}.tiles.mapbox.com/v3/tmpsantos.hgda0m6h/{zoom}/{x}/{y}.png/14/5834/9276 value: org.openstreetmap.josm.data.cache.BufferedImageCacheEntry@1907bc87 rejected from java.util.concurrent.ThreadPoolExecutor@1bd0f37c[Terminated, pool size = 0, active threads = 0, queued tasks = 0, completed tasks = 3898]
java.util.concurrent.RejectedExecutionException: Task PutEvent for key: IBGE Mapa de Setores Urbanos:http://{switch:a,b,c}.tiles.mapbox.com/v3/tmpsantos.hgda0m6h/{zoom}/{x}/{y}.png/14/5834/9276 value: org.openstreetmap.josm.data.cache.BufferedImageCacheEntry@1907bc87 rejected from java.util.concurrent.ThreadPoolExecutor@1bd0f37c[Terminated, pool size = 0, active threads = 0, queued tasks = 0, completed tasks = 3898]

comment:3 Changed 2 years ago by wiktorn

One more question - did this message appear on JOSM close or during normal work and you just happen to notice it on your log window?

comment:4 Changed 2 years ago by naoliv

In one computer I am not seeing this problem anymore, not even when closing JOSM.
I am seeing things like:

2017-01-27 14:41:30.742 INFO: JCS - Host: https://b.tile.openstreetmap.org found not to return 304 codes for If-Modified-Since or If-None-Match headers
2017-01-27 14:41:31.661 INFO: JCS - Host: https://c.tile.openstreetmap.org found not to return 304 codes for If-Modified-Since or If-None-Match headers
2017-01-27 09:04:14.282 INFO: JCS - Host: https://{switch:a,b,c}.tile.openstreetmap.org/{zoom}/{x}/{y}.png found not to return 304 codes for If-Modified-Since or If-None-Match headers

But I guess they are inofensive.
I still need to test at the other computer.

comment:5 Changed 2 years ago by naoliv

Forgot: the version I was using in the above comment is 11507

Modify Ticket

Change Properties
Set your email in Preferences
Action
as new The owner will remain team.
as The resolution will be set.
to The owner will be changed from team to the specified user.
The owner will change to naoliv
as duplicate The resolution will be set to duplicate.The specified ticket will be cross-referenced with this ticket
The owner will be changed from team to anonymous.

Add Comment


E-mail address and name can be saved in the Preferences.

 
Note: See TracTickets for help on using tickets.